/*

*/
#include <windows.h>   // Win32 Sleep()
#include <unistd.h>    // Linux sleep()
#include <stdio.h>
#include <pthread.h>

pthread_mutex_t cv_mutex;
pthread_cond_t  my_condition_variable;

int time_to_move = 0;

int main()
{
   //thread function prototypes
   void *thread1(void *vargp);
   void *thread2(void *vargp);

   pthread_t tid[2];

   // initialize mutex and condition variable objects
   pthread_mutex_init(&cv_mutex, NULL);
   pthread_cond_init (&my_condition_variable, NULL);

   // create the two threads
   printf("Starting threads.\n");
   pthread_create(&(tid[0]), NULL, thread1, NULL);  // should have error checking
   pthread_create(&(tid[1]), NULL, thread2, NULL);

   // wait for both threads to complete
   pthread_join(tid[0], NULL);
   pthread_join(tid[1], NULL);

   // clean up and exit
   printf("Cleaning up threads.\n");
   pthread_mutex_destroy(&cv_mutex);
   pthread_cond_destroy(&my_condition_variable);
   pthread_exit(NULL);
   return 0;  // keep gcc happy
}//main


void *thread1(void *vargp)
{
   //Sleep(2000);
   pthread_mutex_lock(&cv_mutex);  // Try commenting out this line. What happens?
   printf("1. I'm over here.\n");
   if (! time_to_move)
   {
      pthread_cond_wait(&my_condition_variable, &cv_mutex);
   }
   printf("2. No wait, I'm over here!\n");

   pthread_exit(NULL);
   return NULL;  // keep gcc happy
}//thread1


void *thread2(void *vargp)
{
   //Sleep(2000);
   pthread_mutex_lock(&cv_mutex); // What can happen without this critical section?
     printf("1. Time to move.\n");
     time_to_move = 1;
     pthread_cond_signal(&my_condition_variable);
   pthread_mutex_unlock(&cv_mutex);

   pthread_exit(NULL);
   return NULL;  // keep gcc happy
}//thread2
